Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ICB/icbdia.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ICB/icbdia.F90	(revision 9189)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ICB/icbdia.F90	(revision 9190)
@@ -1,4 +1,3 @@
 MODULE icbdia
-
    !!======================================================================
    !!                       ***  MODULE  icbdia  ***
@@ -13,6 +12,20 @@
    !!            -  !                            from the right points in the code
    !!----------------------------------------------------------------------
+ 
    !!----------------------------------------------------------------------
-   !! icb_dia_init : initialise iceberg budgeting
+   !!   icb_dia_init  : initialise iceberg budgeting
+   !!   icb_dia       : global iceberg diagnostics
+   !!   icb_dia_step  : reset at the beginning of each timestep
+   !!   icb_dia_put   : output (via iom_put) iceberg fields
+   !!   icb_dia_calve : 
+   !!   icb_dia_income: 
+   !!   icb_dia_size  : 
+   !!   icb_dia_speed : 
+   !!   icb_dia_melt  : 
+   !!   report_state  : 
+   !!   report_consistant : 
+   !!   report_budget : 
+   !!   report_istate : 
+   !!   report_ibudget: 
    !!----------------------------------------------------------------------
    USE par_oce        ! ocean parameters
@@ -85,5 +98,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( .NOT. ln_bergdia ) RETURN
+      IF( .NOT.ln_bergdia )   RETURN
 
       ALLOCATE( berg_melt    (jpi,jpj)   )           ;   berg_melt   (:,:)   = 0._wp
@@ -136,6 +149,6 @@
 
       floating_mass_start       = icb_utl_mass( first_berg )
-      bergs_mass_start          = icb_utl_mass( first_berg, justbergs=.true. )
-      bits_mass_start           = icb_utl_mass( first_berg, justbits=.true. )
+      bergs_mass_start          = icb_utl_mass( first_berg, justbergs=.TRUE. )
+      bits_mass_start           = icb_utl_mass( first_berg, justbits =.TRUE. )
       IF( lk_mpp ) THEN
          ALLOCATE( rsumbuf(23) )          ; rsumbuf(:) = 0._wp
@@ -159,11 +172,11 @@
       !! for this we pack variables into buffer so we only need one mpp_sum
       !!----------------------------------------------------------------------
-      LOGICAL, INTENT(in) ::   ld_budge
-      !
-      INTEGER             ::   ik
-      REAL(wp)            ::   zunused_calving, ztmpsum, zgrdd_berg_mass, zgrdd_bits_mass
-      !!----------------------------------------------------------------------
-      !
-      IF( .NOT. ln_bergdia )   RETURN
+      LOGICAL, INTENT(in) ::   ld_budge   !
+      !
+      INTEGER ::   ik
+      REAL(wp)::   zunused_calving, ztmpsum, zgrdd_berg_mass, zgrdd_bits_mass
+      !!----------------------------------------------------------------------
+      !
+      IF( .NOT.ln_bergdia )   RETURN
 
       zunused_calving      = SUM( berg_grid%calving(:,:) )
@@ -181,17 +194,17 @@
       ztmpsum              = SUM( berg_grid%calving_hflx(:,:) * e1e2t(:,:) * tmask_i(:,:) )
       calving_out_heat_net = calving_out_heat_net + ztmpsum * berg_dt   ! Units of J
-
+      !
       IF( ld_budge ) THEN
          stored_end        = SUM( berg_grid%stored_ice(:,:,:) )
          stored_heat_end   = SUM( berg_grid%stored_heat(:,:) )
          floating_mass_end = icb_utl_mass( first_berg )
-         bergs_mass_end    = icb_utl_mass( first_berg,justbergs=.true. )
-         bits_mass_end     = icb_utl_mass( first_berg,justbits=.true. )
+         bergs_mass_end    = icb_utl_mass( first_berg,justbergs=.TRUE. )
+         bits_mass_end     = icb_utl_mass( first_berg,justbits =.TRUE. )
          floating_heat_end = icb_utl_heat( first_berg )
-
+         !
          nbergs_end        = icb_utl_count()
          zgrdd_berg_mass   = SUM( berg_mass(:,:)*e1e2t(:,:)*tmask_i(:,:) )
          zgrdd_bits_mass   = SUM( bits_mass(:,:)*e1e2t(:,:)*tmask_i(:,:) )
-
+         !
          IF( lk_mpp ) THEN
             rsumbuf( 1) = stored_end
@@ -218,7 +231,7 @@
             rsumbuf(22) = zgrdd_berg_mass
             rsumbuf(23) = zgrdd_bits_mass
-
+            !
             CALL mpp_sum( rsumbuf(1:23), 23)
-
+            !
             stored_end                = rsumbuf( 1)
             stored_heat_end           = rsumbuf( 2)
@@ -244,5 +257,5 @@
             zgrdd_berg_mass           = rsumbuf(22)
             zgrdd_bits_mass           = rsumbuf(23)
-
+            !
             nsumbuf(1) = nbergs_end
             nsumbuf(2) = nbergs_calved
@@ -252,7 +265,6 @@
                nsumbuf(4+ik) = nbergs_calved_by_class(ik)
             END DO
-
             CALL mpp_sum( nsumbuf(1:nclasses+4), nclasses+4 )
-
+            !
             nbergs_end        = nsumbuf(1)
             nbergs_calved     = nsumbuf(2)
@@ -261,57 +273,57 @@
             DO ik = 1,nclasses
                nbergs_calved_by_class(ik)= nsumbuf(4+ik)
-            ENDDO
-
+            END DO
+            !
          ENDIF
-
-         CALL report_state( 'stored ice','kg','',stored_start,'',stored_end,'')
-         CALL report_state( 'floating','kg','',floating_mass_start,'',floating_mass_end,'',nbergs_end)
-         CALL report_state( 'icebergs','kg','',bergs_mass_start,'',bergs_mass_end,'')
-         CALL report_state( 'bits','kg','',bits_mass_start,'',bits_mass_end,'')
-         CALL report_istate( 'berg #','',nbergs_start,'',nbergs_end,'')
+         !
+         CALL report_state  ( 'stored ice','kg','',stored_start,'',stored_end,'')
+         CALL report_state  ( 'floating','kg','',floating_mass_start,'',floating_mass_end,'',nbergs_end )
+         CALL report_state  ( 'icebergs','kg','',bergs_mass_start,'',bergs_mass_end,'')
+         CALL report_state  ( 'bits','kg','',bits_mass_start,'',bits_mass_end,'')
+         CALL report_istate ( 'berg #','',nbergs_start,'',nbergs_end,'')
          CALL report_ibudget( 'berg #','calved',nbergs_calved, &
-                                       'melted',nbergs_melted, &
-                                       '#',nbergs_start,nbergs_end)
+            &                          'melted',nbergs_melted, &
+            &                          '#',nbergs_start,nbergs_end)
          CALL report_budget( 'stored mass','kg','calving used',calving_used_net, &
-                                           'bergs',calving_to_bergs_net, &
-                                           'stored mass',stored_start,stored_end)
+            &                              'bergs',calving_to_bergs_net, &
+            &                              'stored mass',stored_start,stored_end)
          CALL report_budget( 'floating mass','kg','calving used',calving_to_bergs_net, &
-                                             'bergs',melt_net, &
-                                             'stored mass',floating_mass_start,floating_mass_end)
+            &                                'bergs',melt_net, &
+            &                                'stored mass',floating_mass_start,floating_mass_end)
          CALL report_budget( 'berg mass','kg','calving',calving_to_bergs_net, &
-                                              'melt+eros',berg_melt_net, &
-                                              'berg mass',bergs_mass_start,bergs_mass_end)
+            &                                 'melt+eros',berg_melt_net, &
+            &                                 'berg mass',bergs_mass_start,bergs_mass_end)
          CALL report_budget( 'bits mass','kg','eros used',bits_src_net, &
-                                              'bergs',bits_melt_net, &
-                                              'stored mass',bits_mass_start,bits_mass_end)
+            &                                 'bergs',bits_melt_net, &
+            &                                 'stored mass',bits_mass_start,bits_mass_end)
          CALL report_budget( 'net mass','kg','recvd',calving_rcv_net, &
-                                             'rtrnd',calving_ret_net, &
-                                             'net mass',stored_start+floating_mass_start, &
-                                                        stored_end+floating_mass_end)
+            &                                'rtrnd',calving_ret_net, &
+            &                                'net mass',stored_start+floating_mass_start, &
+            &                                           stored_end+floating_mass_end)
          CALL report_consistant( 'iceberg mass','kg','gridded',zgrdd_berg_mass,'bergs',bergs_mass_end)
          CALL report_consistant( 'bits mass','kg','gridded',zgrdd_bits_mass,'bits',bits_mass_end)
          CALL report_state( 'net heat','J','',stored_heat_start+floating_heat_start,'', &
-                                              stored_heat_end+floating_heat_end,'')
+            &                                 stored_heat_end+floating_heat_end,'')
          CALL report_state( 'stored heat','J','',stored_heat_start,'',stored_heat_end,'')
          CALL report_state( 'floating heat','J','',floating_heat_start,'',floating_heat_end,'')
          CALL report_budget( 'net heat','J','net heat',calving_src_heat_net, &
-                                            'net heat',calving_out_heat_net, &
-                                            'net heat',stored_heat_start+floating_heat_start, &
-                                                       stored_heat_end+floating_heat_end)
+            &                               'net heat',calving_out_heat_net, &
+            &                               'net heat',stored_heat_start+floating_heat_start, &
+            &                                          stored_heat_end+floating_heat_end)
          CALL report_budget( 'stored heat','J','calving used',calving_src_heat_used_net, &
-                                               'bergs',heat_to_bergs_net, &
-                                               'net heat',stored_heat_start,stored_heat_end)
+            &                                  'bergs',heat_to_bergs_net, &
+            &                                  'net heat',stored_heat_start,stored_heat_end)
          CALL report_budget( 'flting heat','J','calved',heat_to_bergs_net, &
-                                               'melt',heat_to_ocean_net, &
-                                               'net heat',floating_heat_start,floating_heat_end)
+            &                                  'melt',heat_to_ocean_net, &
+            &                                  'net heat',floating_heat_start,floating_heat_end)
          IF (nn_verbose_level >= 1) THEN
             CALL report_consistant( 'top interface','kg','from SIS',calving_src_net, &
-                                    'received',calving_rcv_net)
+               &                    'received',calving_rcv_net)
             CALL report_consistant( 'bot interface','kg','sent',calving_out_net, &
-                                    'returned',calving_ret_net)
+               &                    'returned',calving_ret_net)
          ENDIF
          WRITE( numicb, '("calved by class = ",i6,20(",",i6))') (nbergs_calved_by_class(ik),ik=1,nclasses)
-         IF ( nspeeding_tickets > 0 ) WRITE( numicb, '("speeding tickets issued = ",i6)') nspeeding_tickets
-
+         IF( nspeeding_tickets > 0 )   WRITE( numicb, '("speeding tickets issued = ",i6)') nspeeding_tickets
+         !
          nbergs_start              = nbergs_end
          stored_start              = stored_end
@@ -350,15 +362,15 @@
       !!----------------------------------------------------------------------
       !
-      IF( .NOT. ln_bergdia ) RETURN
-      berg_melt    (:,:)   = 0._wp
-      buoy_melt    (:,:)   = 0._wp
-      eros_melt    (:,:)   = 0._wp
-      conv_melt    (:,:)   = 0._wp
-      bits_src     (:,:)   = 0._wp
-      bits_melt    (:,:)   = 0._wp
-      bits_mass    (:,:)   = 0._wp
-      berg_mass    (:,:)   = 0._wp
-      virtual_area (:,:)   = 0._wp
-      real_calving (:,:,:) = 0._wp
+      IF( .NOT.ln_bergdia )   RETURN
+      berg_melt   (:,:)   = 0._wp
+      buoy_melt   (:,:)   = 0._wp
+      eros_melt   (:,:)   = 0._wp
+      conv_melt   (:,:)   = 0._wp
+      bits_src    (:,:)   = 0._wp
+      bits_melt   (:,:)   = 0._wp
+      bits_mass   (:,:)   = 0._wp
+      berg_mass   (:,:)   = 0._wp
+      virtual_area(:,:)   = 0._wp
+      real_calving(:,:,:) = 0._wp
       !
    END SUBROUTINE icb_dia_step
@@ -369,5 +381,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( .NOT. ln_bergdia )   RETURN            !!gm useless iom will control whether it is output or not
+      IF( .NOT.ln_bergdia )   RETURN            !!gm useless iom will control whether it is output or not
       !
       CALL iom_put( "berg_melt"        , berg_melt   (:,:)   )   ! Melt rate of icebergs                     [kg/m2/s]
@@ -388,5 +400,5 @@
       !!----------------------------------------------------------------------
       !!----------------------------------------------------------------------
-      INTEGER,  INTENT(in)  ::   ki, kj, kn
+      INTEGER , INTENT(in)  ::   ki, kj, kn
       REAL(wp), INTENT(in)  ::   pcalved
       REAL(wp), INTENT(in)  ::   pheated
@@ -411,5 +423,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( .NOT. ln_bergdia ) RETURN
+      IF( .NOT.ln_bergdia )   RETURN
       !
       IF( kt == nit000 ) THEN
@@ -437,9 +449,9 @@
       !!----------------------------------------------------------------------
       !!----------------------------------------------------------------------
-      INTEGER,  INTENT(in) :: ki, kj
-      REAL(wp), INTENT(in) :: pWn, pLn, pAbits, pmass_scale, pMnew, pnMbits, pz1_e1e2
-      !!----------------------------------------------------------------------
-      !
-      IF( .NOT. ln_bergdia ) RETURN
+      INTEGER , INTENT(in) ::   ki, kj
+      REAL(wp), INTENT(in) ::   pWn, pLn, pAbits, pmass_scale, pMnew, pnMbits, pz1_e1e2
+      !!----------------------------------------------------------------------
+      !
+      IF( .NOT.ln_bergdia )   RETURN
       virtual_area(ki,kj) = virtual_area(ki,kj) + ( pWn * pLn + pAbits ) * pmass_scale      ! m^2
       berg_mass(ki,kj)    = berg_mass(ki,kj) + pMnew * pz1_e1e2                             ! kg/m2
@@ -453,5 +465,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( .NOT. ln_bergdia ) RETURN
+      IF( .NOT.ln_bergdia )   RETURN
       nspeeding_tickets = nspeeding_tickets + 1
       !
@@ -459,7 +471,7 @@
 
 
-   SUBROUTINE icb_dia_melt(ki, kj, pmnew, pheat, pmass_scale,   &
-      &                   pdM, pdMbitsE, pdMbitsM, pdMb, pdMe,   &
-      &                   pdMv, pz1_dt_e1e2 )
+   SUBROUTINE icb_dia_melt(ki, kj, pmnew, pheat, pmass_scale,     &
+      &                    pdM, pdMbitsE, pdMbitsM, pdMb, pdMe,   &
+      &                    pdMv, pz1_dt_e1e2 )
       !!----------------------------------------------------------------------
       !!----------------------------------------------------------------------
@@ -469,6 +481,6 @@
       !!----------------------------------------------------------------------
       !
-      IF( .NOT. ln_bergdia ) RETURN
-
+      IF( .NOT.ln_bergdia )   RETURN
+      !
       berg_melt (ki,kj) = berg_melt (ki,kj) + pdM      * pz1_dt_e1e2   ! kg/m2/s
       bits_src  (ki,kj) = bits_src  (ki,kj) + pdMbitsE * pz1_dt_e1e2   ! mass flux into bergy bitskg/m2/s
@@ -492,17 +504,18 @@
       !!----------------------------------------------------------------------
       !
-      IF ( PRESENT(kbergs) ) THEN
+      IF( PRESENT(kbergs) ) THEN
          WRITE(numicb,100) cd_budgetstr // ' state:',                                    &
-                           cd_startstr  // ' start',  pstartval,         cd_budgetunits, &
-                           cd_endstr    // ' end',    pendval,           cd_budgetunits, &
-                           'Delta '     // cd_delstr, pendval-pstartval, cd_budgetunits, &
-                           '# of bergs', kbergs
+            &              cd_startstr  // ' start',  pstartval,         cd_budgetunits, &
+            &              cd_endstr    // ' end',    pendval,           cd_budgetunits, &
+            &              'Delta '     // cd_delstr, pendval-pstartval, cd_budgetunits, &
+            &              '# of bergs', kbergs
       ELSE
          WRITE(numicb,100) cd_budgetstr // ' state:',                                   &
-                           cd_startstr  // ' start', pstartval,         cd_budgetunits, &
-                           cd_endstr    // ' end',   pendval,           cd_budgetunits, &
-                           cd_delstr    // 'Delta',  pendval-pstartval, cd_budgetunits
+            &              cd_startstr  // ' start', pstartval,         cd_budgetunits, &
+            &              cd_endstr    // ' end',   pendval,           cd_budgetunits, &
+            &              cd_delstr    // 'Delta',  pendval-pstartval, cd_budgetunits
       ENDIF
-      100 FORMAT(a19,3(a18,"=",es14.7,x,a2,:,","),a12,i8)
+100   FORMAT(a19,3(a18,"=",es14.7,x,a2,:,","),a12,i8)
+      !
    END SUBROUTINE report_state
 
@@ -516,8 +529,9 @@
       !
       WRITE(numicb,200) cd_budgetstr // ' check:',                 &
-                        cd_startstr,    pstartval, cd_budgetunits, &
-                        cd_endstr,      pendval,   cd_budgetunits, &
-                        'error',        (pendval-pstartval)/((pendval+pstartval)+1e-30), 'nd'
-      200 FORMAT(a19,10(a18,"=",es14.7,x,a2,:,","))
+         &              cd_startstr,    pstartval, cd_budgetunits, &
+         &              cd_endstr,      pendval,   cd_budgetunits, &
+         &              'error',        (pendval-pstartval)/((pendval+pstartval)+1e-30), 'nd'
+200   FORMAT(a19,10(a18,"=",es14.7,x,a2,:,","))
+      !
    END SUBROUTINE report_consistant
 
@@ -530,10 +544,10 @@
       REAL(wp),      INTENT(in) :: pinval, poutval, pstartval, pendval
       !
-      REAL(wp)                  :: zval
+      REAL(wp) ::   zval
       !!----------------------------------------------------------------------
       !
       zval = ( ( pendval - pstartval ) - ( pinval - poutval ) ) /   &
-         &   MAX( 1.e-30, MAX( abs( pendval - pstartval ) , ABS( pinval - poutval ) ) )
-
+         &   MAX( 1.e-30, MAX( ABS( pendval - pstartval ) , ABS( pinval - poutval ) ) )
+         !
       WRITE(numicb,200) cd_budgetstr // ' budget:', &
          &              cd_instr     // ' in',      pinval,         cd_budgetunits, &
@@ -549,6 +563,7 @@
       !!----------------------------------------------------------------------
       !!----------------------------------------------------------------------
-      CHARACTER*(*), INTENT(in) :: cd_budgetstr, cd_startstr, cd_endstr, cd_delstr
-      INTEGER,       INTENT(in) :: pstartval, pendval
+      CHARACTER*(*), INTENT(in) ::   cd_budgetstr, cd_startstr, cd_endstr, cd_delstr
+      INTEGER      , INTENT(in) ::   pstartval, pendval
+      !!----------------------------------------------------------------------
       !
       WRITE(numicb,100) cd_budgetstr // ' state:',           &
@@ -570,9 +585,10 @@
       !
       WRITE(numicb,200) cd_budgetstr // ' budget:', &
-                        cd_instr     // ' in',      pinval, &
-                        cd_outstr    // ' out',     poutval, &
-                        'Delta '     // cd_delstr,  pinval-poutval, &
-                        'error',                    ( ( pendval - pstartval ) - ( pinval - poutval ) )
-      200 FORMAT(a19,10(a18,"=",i14,x,:,","))
+         &              cd_instr     // ' in',      pinval, &
+         &              cd_outstr    // ' out',     poutval, &
+         &              'Delta '     // cd_delstr,  pinval-poutval, &
+         &              'error',                    ( ( pendval - pstartval ) - ( pinval - poutval ) )
+200   FORMAT(a19,10(a18,"=",i14,x,:,","))
+      !
    END SUBROUTINE report_ibudget
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ICB/icbdyn.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ICB/icbdyn.F90	(revision 9189)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ICB/icbdyn.F90	(revision 9190)
@@ -1,15 +1,13 @@
 MODULE icbdyn
-
    !!======================================================================
    !!                       ***  MODULE  icbdyn  ***
    !! Iceberg:  time stepping routine for iceberg tracking
    !!======================================================================
-   !! History : 3.3.1 !  2010-01  (Martin&Adcroft) Original code
-   !!            -    !  2011-03  (Madec)          Part conversion to NEMO form
-   !!            -    !                            Removal of mapping from another grid
-   !!            -    !  2011-04  (Alderson)       Split into separate modules
-   !!            -    !  2011-05  (Alderson)       Replace broken grounding routine
-   !!            -    !                            with one of Gurvan's suggestions (just like
-   !!            -    !                            the broken one)
+   !! History :  3.3  !  2010-01  (Martin&Adcroft)  Original code
+   !!             -   !  2011-03  (Madec)  Part conversion to NEMO form
+   !!             -   !                    Removal of mapping from another grid
+   !!             -   !  2011-04  (Alderson)  Split into separate modules
+   !!             -   !  2011-05  (Alderson)  Replace broken grounding routine with one of
+   !!             -   !                       Gurvan's suggestions (just like the broken one)
    !!----------------------------------------------------------------------
    USE par_oce        ! NEMO parameters
@@ -41,16 +39,17 @@
       !! ** Method  : - See Martin & Adcroft, Ocean Modelling 34, 2010
       !!----------------------------------------------------------------------
-      REAL(wp)                        ::   zuvel1 , zvvel1 , zu1, zv1, zax1, zay1, zxi1 , zyj1
-      REAL(wp)                        ::   zuvel2 , zvvel2 , zu2, zv2, zax2, zay2, zxi2 , zyj2
-      REAL(wp)                        ::   zuvel3 , zvvel3 , zu3, zv3, zax3, zay3, zxi3 , zyj3
-      REAL(wp)                        ::   zuvel4 , zvvel4 , zu4, zv4, zax4, zay4, zxi4 , zyj4
-      REAL(wp)                        ::   zuvel_n, zvvel_n, zxi_n   , zyj_n
-      REAL(wp)                        ::   zdt, zdt_2, zdt_6, ze1, ze2
-      LOGICAL                         ::   ll_bounced
-      TYPE(iceberg), POINTER          ::   berg
-      TYPE(point)  , POINTER          ::   pt
-      INTEGER                         ::   kt
-      !!----------------------------------------------------------------------
-
+      INTEGER, INTENT(in) ::   kt   !
+      !
+      LOGICAL  ::   ll_bounced
+      REAL(wp) ::   zuvel1 , zvvel1 , zu1, zv1, zax1, zay1, zxi1 , zyj1
+      REAL(wp) ::   zuvel2 , zvvel2 , zu2, zv2, zax2, zay2, zxi2 , zyj2
+      REAL(wp) ::   zuvel3 , zvvel3 , zu3, zv3, zax3, zay3, zxi3 , zyj3
+      REAL(wp) ::   zuvel4 , zvvel4 , zu4, zv4, zax4, zay4, zxi4 , zyj4
+      REAL(wp) ::   zuvel_n, zvvel_n, zxi_n   , zyj_n
+      REAL(wp) ::   zdt, zdt_2, zdt_6, ze1, ze2
+      TYPE(iceberg), POINTER ::   berg
+      TYPE(point)  , POINTER ::   pt
+      !!----------------------------------------------------------------------
+      !
       ! 4th order Runge-Kutta to solve:   d/dt X = V,  d/dt V = A
       !                    with I.C.'s:   X=X1 and V=V1
@@ -75,5 +74,5 @@
          pt => berg%current_point
 
-         ll_bounced = .false.
+         ll_bounced = .FALSE.
 
 
@@ -99,5 +98,5 @@
          !
          CALL icb_ground( zxi2, zxi1, zu1,   &
-         &                zyj2, zyj1, zv1, ll_bounced )
+            &             zyj2, zyj1, zv1, ll_bounced )
 
          !                                         !**   A2 = A(X2,V2)
@@ -115,5 +114,5 @@
          !
          CALL icb_ground( zxi3, zxi1, zu3,   &
-         &                zyj3, zyj1, zv3, ll_bounced )
+            &                zyj3, zyj1, zv3, ll_bounced )
 
          !                                         !**   A3 = A(X3,V3)
@@ -131,5 +130,5 @@
 
          CALL icb_ground( zxi4, zxi1, zu4,   &
-         &                zyj4, zyj1, zv4, ll_bounced )
+            &             zyj4, zyj1, zv4, ll_bounced )
 
          !                                         !**   A4 = A(X4,V4)
@@ -150,5 +149,5 @@
 
          CALL icb_ground( zxi_n, zxi1, zuvel_n,   &
-         &                      zyj_n, zyj1, zvvel_n, ll_bounced )
+            &             zyj_n, zyj1, zvvel_n, ll_bounced )
 
          pt%uvel = zuvel_n                        !** save in berg structure
@@ -169,5 +168,5 @@
 
    SUBROUTINE icb_ground( pi, pi0, pu,   &
-      &                         pj, pj0, pv, ld_bounced )
+      &                   pj, pj0, pv, ld_bounced )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE icb_ground  ***
@@ -216,18 +215,18 @@
       ibounce_method = 2
       SELECT CASE ( ibounce_method )
-         CASE ( 1 )
-            pi = pi0
-            pj = pj0
-            pu = 0._wp
-            pv = 0._wp
-         CASE ( 2 )
-            IF( ii0 /= ii ) THEN
-               pi = pi0                   ! return back to the initial position
-               pu = 0._wp                 ! zeroing of velocity in the direction of the grounding
-            ENDIF
-            IF( ij0 /= ij ) THEN
-               pj = pj0                   ! return back to the initial position
-               pv = 0._wp                 ! zeroing of velocity in the direction of the grounding
-            ENDIF
+      CASE ( 1 )
+         pi = pi0
+         pj = pj0
+         pu = 0._wp
+         pv = 0._wp
+      CASE ( 2 )
+         IF( ii0 /= ii ) THEN
+            pi = pi0                   ! return back to the initial position
+            pu = 0._wp                 ! zeroing of velocity in the direction of the grounding
+         ENDIF
+         IF( ij0 /= ij ) THEN
+            pj = pj0                   ! return back to the initial position
+            pv = 0._wp                 ! zeroing of velocity in the direction of the grounding
+         ENDIF
       END SELECT
       !
@@ -259,5 +258,6 @@
       !
       INTEGER  ::   itloop
-      REAL(wp) ::   zuo, zvo, zui, zvi, zua, zva, zuwave, zvwave, zssh_x, zssh_y, zsst, zcn, zhi
+      REAL(wp) ::   zuo, zui, zua, zuwave, zssh_x, zsst, zcn, zhi
+      REAL(wp) ::   zvo, zvi, zva, zvwave, zssh_y
       REAL(wp) ::   zff, zT, zD, zW, zL, zM, zF
       REAL(wp) ::   zdrag_ocn, zdrag_atm, zdrag_ice, zwave_rad
@@ -339,5 +339,5 @@
             zaxe = zaxe - zdrag_ocn*(puvel -zuo) - zdrag_atm*(puvel -zua) -zdrag_ice*(puvel -zui)
             zaye = zaye - zdrag_ocn*(pvvel -zvo) - zdrag_atm*(pvvel -zva) -zdrag_ice*(pvvel -zvi)
-         endif
+         ENDIF
 
          ! Solve for implicit accelerations
@@ -349,7 +349,7 @@
             pax     = zdetA * ( zA11*zaxe + zA12*zaye )
             pay     = zdetA * ( zA11*zaye - zA12*zaxe )
-         else
+         ELSE
             pax = zaxe   ;   pay = zaye
-         endif
+         ENDIF
 
          zuveln = puvel0 + pdt*pax
@@ -362,5 +362,5 @@
          IF( zspeed > 0._wp ) THEN
             zloc_dx = MIN( pe1, pe2 )                          ! minimum grid spacing
-            zspeed_new = zloc_dx / pdt * rn_speed_limit     ! Speed limit as a factor of dx / dt
+            zspeed_new = zloc_dx / pdt * rn_speed_limit        ! Speed limit as a factor of dx / dt
             IF( zspeed_new < zspeed ) THEN
                zuveln = zuveln * ( zspeed_new / zspeed )        ! Scale velocity to reduce speed
